﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Interfaces;

namespace Sage.PL.WebAPI.Demo.DAL.Repositories
{
	public class AliveRepository
	{
		private readonly IAliveController aliveController;
		private readonly HttpResponseService httpResponseService;

		public AliveRepository(IAliveController aliveController, HttpResponseService httpResponseService)
		{
			this.aliveController = aliveController;
			this.httpResponseService = httpResponseService;
		}

		public ResponseResult<string> Get()
		{
			ResponseResult<string> result;

			var message = aliveController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<string>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
	}
}
