﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.FKF.AccountsChart.Interfaces;
using Sage.PL.WebAPI.Interface.FKF.AccountsChart.ViewModels;
using Sage.PL.WebAPI.Interface.FKF.Employees.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.Repositories
{
	public class FKAccountsChartRepository
	{
		private readonly IFKAccountsChartController accountsChartController;
		private readonly HttpResponseService httpResponseService;

		public FKAccountsChartRepository(IFKAccountsChartController accountsChartController, HttpResponseService httpResponseService)
		{
			this.accountsChartController = accountsChartController;
			this.httpResponseService = httpResponseService;
		}

		public ResponseResult<List<AccountChartElementSimple>> GetFlatList(int yearId)
		{
			ResponseResult<List<AccountChartElementSimple>> result;
			var message = accountsChartController.GetFlatList(yearId) as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<AccountChartElementSimple>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
	}
}
