﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Common.Interfaces;
using Sage.PL.WebAPI.Interface.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.Repositories
{
	public class PaymentFormsRepository
	{
		private readonly IPaymentFormsController paymentFormsController;
		private readonly HttpResponseService httpResponseService;

		public PaymentFormsRepository(IPaymentFormsController paymentFormsController, HttpResponseService httpResponseService)
		{
			this.paymentFormsController = paymentFormsController;
			this.httpResponseService = httpResponseService;
		}

		public ResponseResult<List<PaymentForm>> Get()
		{
			ResponseResult<List<PaymentForm>> result;
			var message = paymentFormsController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<PaymentForm>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<List<PaymentForm>> Get(int registryId)
		{
			ResponseResult<List<PaymentForm>> result;
			var message = paymentFormsController.Get(registryId) as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<PaymentForm>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
	}
}
