﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Interfaces;
using Sage.PL.WebAPI.Interface.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.Repositories
{
	public class PingRepository
	{
		private readonly IPingController pingController;
		private readonly HttpResponseService httpResponseService;

		public PingRepository(IPingController pingController, HttpResponseService httpResponseService)
		{
			this.pingController = pingController;
			this.httpResponseService = httpResponseService;
		}

		public ResponseResult<Ping> Get()
		{
			ResponseResult<Ping> result;

			var message = pingController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<Ping>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
	}
}
