﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Products.Interfaces;
using Sage.PL.WebAPI.Interface.Products.ViewModels.PriceCalculations;

namespace Sage.PL.WebAPI.Demo.DAL.Repositories
{
	public class ProductPricesRepository
	{
		private readonly IProductPricesController productPricesController;
		private readonly HttpResponseService httpResponseService;

		public ProductPricesRepository(IProductPricesController productPricesController, HttpResponseService httpResponseService)
		{
			this.productPricesController = productPricesController;
			this.httpResponseService = httpResponseService;
		}

		public ResponseResult<PriceCalculationResult> CalculatePrices(PriceCalculationCriteria criteria)
		{
			ResponseResult<PriceCalculationResult> result;
			var message = productPricesController.CalculatePrices(criteria) as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<PriceCalculationResult>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<PriceOrderResult> OrderPrices(PriceOrderCriteria criteria)
		{
			ResponseResult<PriceOrderResult> result;
			var message = productPricesController.OrderPrices(criteria) as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<PriceOrderResult>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
	}
}
