﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Interfaces;

namespace Sage.PL.WebAPI.Demo.DAL.Repositories
{
	public class SessionRepository
	{
		private readonly ISessionController sessionController;
		private readonly HttpResponseService httpResponseService;

		public SessionRepository(ISessionController sessionController, HttpResponseService httpResponseService)
		{
			this.sessionController = sessionController;
			this.httpResponseService = httpResponseService;
		}

		public ResponseResult<string> OpenNewSession(string deviceName)
		{
			ResponseResult<string> result;

			var message = sessionController.OpenNewSession(deviceName) as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<string>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<string> CloseSession()
		{
			ResponseResult<string> result;

			var message = sessionController.CloseSession() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<string>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}

	}
}
