﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Demo.Interchange.Handlers;

namespace Sage.PL.WebAPI.Demo.DAL.Repositories
{
	public class TestRepository
	{
		private readonly TestsHandler testsHandler;
		private readonly HttpResponseService httpResponseService;

		public TestRepository(TestsHandler testsHandler, HttpResponseService httpResponseService)
		{
			this.testsHandler = testsHandler;
			this.httpResponseService = httpResponseService;
		}

		public ResponseResult<string> CloseSession(string sessionGuid)
		{
			ResponseResult<string> result;

			var message = testsHandler.CloseSession(sessionGuid) as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<string>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
	}
}
