﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace Sage.PL.WebAPI.Demo.DAL
{
	public class ResponseError
	{
		public HttpError HttpError { get; internal set; }
		public string Message
		{
			get
			{
				if (HttpError != null && HttpError.ContainsKey("Message"))
					return HttpError["Message"] as string;
				return null;
			}
		}
		public string ExceptionMessage
		{
			get
			{
				if (HttpError != null && HttpError.ContainsKey("ExceptionMessage"))
					return HttpError["ExceptionMessage"] as string;
				return null;
			}
		}
		public string ExceptionType
		{
			get
			{
				if (HttpError != null && HttpError.ContainsKey("ExceptionType"))
					return HttpError["ExceptionType"] as string;
				return null;
			}
		}
		public string StackTrace
		{
			get
			{
				if (HttpError != null && HttpError.ContainsKey("StackTrace"))
					return HttpError["StackTrace"] as string;
				return null;
			}
		}
		public Dictionary<string, string[]> ModelState
		{
			get
			{
				if (HttpError != null && HttpError.ContainsKey("ModelState"))
				{
					try
					{
						JObject jObject = HttpError["ModelState"] as JObject;
						if (jObject != null)
							return JsonConvert.DeserializeObject<Dictionary<string, string[]>>(jObject.ToString());
					}
					catch (Exception)
					{
						return null;
					}
				}

				return null;
			}
		}
	}
}
