﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;

namespace Sage.PL.WebAPI.Demo.DAL.Services
{
	public class HttpResponseService
	{
		public ResponseResult<T> ParseResponse<T>(HttpResponseMessage response)
		{
			ResponseResult<T> result = new ResponseResult<T>();
			result.IsSucceed = response.IsSuccessStatusCode;
			result.StatusCode = response.StatusCode;
			result.RequestUri = response.RequestMessage?.RequestUri;
			if (response.IsSuccessStatusCode)
				result.Object = response.Content.ReadAsAsync<T>().Result;
			else if (response.Content != null)
			{
				result.Error = new ResponseError()
				{
					HttpError = response.Content.ReadAsAsync<HttpError>().Result,
				};
			}

			return result;
		}
	}
}
