﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Common.Interfaces;
using Sage.PL.WebAPI.Interface.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.StaticRepositories
{
	public class CurrenciesRepository
	{
		private readonly ICurrenciesController currenciesController;
		private readonly HttpResponseService httpResponseService;

		public CurrenciesRepository(ICurrenciesController currenciesController, HttpResponseService httpResponseService)
		{
			this.currenciesController = currenciesController;
			this.httpResponseService = httpResponseService;
		}

		private ResponseResult<List<Currency>> staticObj;
		public ResponseResult<List<Currency>> Get()
		{
			ResponseResult<List<Currency>> result;
			var message = currenciesController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<Currency>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<List<Currency>> GetStatic()
		{
			if (staticObj == null || !staticObj.IsSucceed)
				staticObj = Get();

			return staticObj;
		}
	}
}
