﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Common.Interfaces;
using Sage.PL.WebAPI.Interface.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.StaticRepositories
{
	public class DepartmentsRepository
	{
		private readonly IDepartmentsController departmentsController;
		private readonly HttpResponseService httpResponseService;

		public DepartmentsRepository(IDepartmentsController departmentsController, HttpResponseService httpResponseService)
		{
			this.departmentsController = departmentsController;
			this.httpResponseService = httpResponseService;
		}

		private ResponseResult<List<Department>> staticObj;
		public ResponseResult<List<Department>> Get()
		{
			ResponseResult<List<Department>> result;
			var message = departmentsController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<Department>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<List<Department>> GetStatic()
		{
			if (staticObj == null || !staticObj.IsSucceed)
				staticObj = Get();

			return staticObj;
		}
	}
}
