﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.FKF.Common.Interfaces;
using Sage.PL.WebAPI.Interface.FKF.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.StaticRepositories
{
	public class FKCountriesRepository
	{
		private readonly IFKCountriesController countriesController;
		private readonly HttpResponseService httpResponseService;

		public FKCountriesRepository(IFKCountriesController countriesController, HttpResponseService httpResponseService)
		{
			this.countriesController = countriesController;
			this.httpResponseService = httpResponseService;
		}

		private ResponseResult<List<Country>> staticObj;
		public ResponseResult<List<Country>> Get()
		{
			ResponseResult<List<Country>> result;
			var message = countriesController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<Country>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<List<Country>> GetStatic()
		{
			if (staticObj == null || !staticObj.IsSucceed)
				staticObj = Get();

			return staticObj;
		}
	}
}
