﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.FKF.Common.Interfaces;
using Sage.PL.WebAPI.Interface.FKF.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.StaticRepositories
{
	public class FKRegionsRepository
	{
		private readonly IFKRegionsController regionsController;
		private readonly HttpResponseService httpResponseService;

		public FKRegionsRepository(IFKRegionsController regionsController, HttpResponseService httpResponseService)
		{
			this.regionsController = regionsController;
			this.httpResponseService = httpResponseService;
		}

		private ResponseResult<List<Region>> staticObj;
		public ResponseResult<List<Region>> Get()
		{
			ResponseResult<List<Region>> result;
			var message = regionsController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<Region>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<List<Region>> GetStatic()
		{
			if (staticObj == null || !staticObj.IsSucceed)
				staticObj = Get();

			return staticObj;
		}
	}
}
