﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Common.Interfaces;
using Sage.PL.WebAPI.Interface.Common.ViewModels;
using Sage.PL.WebAPI.Interface.FKF.Common.Interfaces;
using Sage.PL.WebAPI.Interface.FKF.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.StaticRepositories
{
	public class FKYearsRepository
	{
		private readonly IFKYearsController yearsController;
		private readonly HttpResponseService httpResponseService;

		public FKYearsRepository(IFKYearsController yearsController, HttpResponseService httpResponseService)
		{
			this.yearsController = yearsController;
			this.httpResponseService = httpResponseService;
		}

		private ResponseResult<List<Year>> staticObj;
		public ResponseResult<List<Year>> Get()
		{
			ResponseResult<List<Year>> result;
			var message = yearsController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<Year>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<List<Year>> GetStatic()
		{
			if (staticObj == null || !staticObj.IsSucceed)
				staticObj = Get();

			return staticObj;
		}
	}
}
