﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Common.Interfaces;
using Sage.PL.WebAPI.Interface.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.StaticRepositories
{
	public class PaymentRegistriesRepository
	{
		private readonly IPaymentRegistriesController paymentRegistriesController;
		private readonly HttpResponseService httpResponseService;

		public PaymentRegistriesRepository(IPaymentRegistriesController paymentRegistriesController, HttpResponseService httpResponseService)
		{
			this.paymentRegistriesController = paymentRegistriesController;
			this.httpResponseService = httpResponseService;
		}

		private ResponseResult<List<PaymentRegistry>> staticObj;
		public ResponseResult<List<PaymentRegistry>> Get()
		{
			ResponseResult<List<PaymentRegistry>> result;
			var message = paymentRegistriesController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<PaymentRegistry>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<List<PaymentRegistry>> GetStatic()
		{
			if (staticObj == null || !staticObj.IsSucceed)
				staticObj = Get();

			return staticObj;
		}
	}
}
