﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Common.Interfaces;
using Sage.PL.WebAPI.Interface.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.StaticRepositories
{
	public class PricesRepository
	{
		private readonly IPricesController pricesController;
		private readonly HttpResponseService httpResponseService;

		public PricesRepository(IPricesController pricesController, HttpResponseService httpResponseService)
		{
			this.pricesController = pricesController;
			this.httpResponseService = httpResponseService;
		}

		private ResponseResult<List<PriceType>> staticObj;
		public ResponseResult<List<PriceType>> Get()
		{
			ResponseResult<List<PriceType>> result;
			var message = pricesController.GetSalePriceTypes() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<PriceType>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<List<PriceType>> GetSalePriceTypesStatic()
		{
			if (staticObj == null || !staticObj.IsSucceed)
				staticObj = Get();

			return staticObj;
		}
	}
}
