﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.DAL.Services;
using Sage.PL.WebAPI.Interface.Common.Interfaces;
using Sage.PL.WebAPI.Interface.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.DAL.StaticRepositories
{
	public class UnitsOfMeasurementRepository
	{
		private readonly IUnitsOfMeasurementController unitsOfMeasurementController;
		private readonly HttpResponseService httpResponseService;

		public UnitsOfMeasurementRepository(IUnitsOfMeasurementController unitsOfMeasurementController, HttpResponseService httpResponseService)
		{
			this.unitsOfMeasurementController = unitsOfMeasurementController;
			this.httpResponseService = httpResponseService;
		}

		private ResponseResult<List<UnitOfMeasurement>> staticObj;
		public ResponseResult<List<UnitOfMeasurement>> Get()
		{
			ResponseResult<List<UnitOfMeasurement>> result;
			var message = unitsOfMeasurementController.Get() as ResponseMessageResult;
			if (message != null)
				result = httpResponseService.ParseResponse<List<UnitOfMeasurement>>(message.Response);
			else
				throw new ArgumentNullException(nameof(message));

			return result;
		}
		public ResponseResult<List<UnitOfMeasurement>> GetStatic()
		{
			if (staticObj == null || !staticObj.IsSucceed)
				staticObj = Get();

			return staticObj;
		}
	}
}
