﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace Sage.PL.WebAPI.Demo.Interchange.Extensions
{
	public static class UriExtensions
	{
		public static Uri SetPath(this Uri uri, string path)
		{
			UriBuilder uriBuilder = new UriBuilder(uri);
			uriBuilder.Path = path;
			return uriBuilder.Uri;
		}

		public static Uri AppendQuery(this Uri uri, string parameterName, string parameterValue)
		{
			parameterName = WebUtility.UrlEncode(parameterName);
			parameterValue = WebUtility.UrlEncode(parameterValue);

			UriBuilder uriBuilder = new UriBuilder(uri);
			if (string.IsNullOrEmpty(uriBuilder.Query))
				uriBuilder.Query = string.Format("{0}={1}", parameterName, parameterValue);
			else
				uriBuilder.Query = string.Format("{0}&{1}={2}", uriBuilder.Query.TrimStart('?'), parameterName, parameterValue);

			return uriBuilder.Uri;
		}
	}
}
