﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.Interchange.Extensions;
using Sage.PL.WebAPI.Interface.FKF.Documents.Interfaces;
using Unity.Attributes;

namespace Sage.PL.WebAPI.Demo.Interchange.Handlers
{
	public class FKDocumentsIssueHandler : IFKDocumentsIssueController
	{
		private readonly HttpClient httpClient;
		private readonly string sessionGuid;

		public FKDocumentsIssueHandler(HttpClient httpClient, [Dependency("SessionGuid")] string sessionGuid)
		{
			this.httpClient = httpClient;
			this.sessionGuid = sessionGuid;
		}

		public IHttpActionResult AddNew([FromBody] Interface.FKF.Documents.ViewModels.Issue.Simple.DocumentIssue documentIssue)
		{
			Uri uri = httpClient.BaseAddress.SetPath("/api/FKDocumentsIssue/NewSimple");
			var request = new HttpRequestMessage();
			request.RequestUri = uri;
			request.Method = HttpMethod.Post;
			request.Headers.Authorization = new AuthenticationHeaderValue("Session", sessionGuid);
			request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
			request.Content = new ObjectContent<Interface.FKF.Documents.ViewModels.Issue.Simple.DocumentIssue>(documentIssue, new JsonMediaTypeFormatter(), new MediaTypeHeaderValue("application/json"));

			var response = httpClient.SendAsync(request);
			return new ResponseMessageResult(response.Result);
		}
		public IHttpActionResult AddNew([FromBody] Interface.FKF.Documents.ViewModels.Issue.SaleInvoice.DocumentIssue documentIssue)
		{
			Uri uri = httpClient.BaseAddress.SetPath("/api/FKDocumentsIssue/NewSaleInvoice");
			var request = new HttpRequestMessage();
			request.RequestUri = uri;
			request.Method = HttpMethod.Post;
			request.Headers.Authorization = new AuthenticationHeaderValue("Session", sessionGuid);
			request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
			request.Content = new ObjectContent<Interface.FKF.Documents.ViewModels.Issue.SaleInvoice.DocumentIssue>(documentIssue, new JsonMediaTypeFormatter(), new MediaTypeHeaderValue("application/json"));

			var response = httpClient.SendAsync(request);
			return new ResponseMessageResult(response.Result);
		}
		public IHttpActionResult AddNew([FromBody] Interface.FKF.Documents.ViewModels.Issue.PurchaseInvoice.DocumentIssue documentIssue)
		{
			Uri uri = httpClient.BaseAddress.SetPath("/api/FKDocumentsIssue/NewPurchaseInvoice");
			var request = new HttpRequestMessage();
			request.RequestUri = uri;
			request.Method = HttpMethod.Post;
			request.Headers.Authorization = new AuthenticationHeaderValue("Session", sessionGuid);
			request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
			request.Content = new ObjectContent<Interface.FKF.Documents.ViewModels.Issue.PurchaseInvoice.DocumentIssue>(documentIssue, new JsonMediaTypeFormatter(), new MediaTypeHeaderValue("application/json"));

			var response = httpClient.SendAsync(request);
			return new ResponseMessageResult(response.Result);
		}
		public IHttpActionResult AddNew([FromBody] Interface.FKF.Documents.ViewModels.Issue.Custom.DocumentIssue documentIssue)
		{
			Uri uri = httpClient.BaseAddress.SetPath("/api/FKDocumentsIssue/NewCustom");
			var request = new HttpRequestMessage();
			request.RequestUri = uri;
			request.Method = HttpMethod.Post;
			request.Headers.Authorization = new AuthenticationHeaderValue("Session", sessionGuid);
			request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
			request.Content = new ObjectContent<Interface.FKF.Documents.ViewModels.Issue.Custom.DocumentIssue>(documentIssue, new JsonMediaTypeFormatter(), new MediaTypeHeaderValue("application/json"));

			var response = httpClient.SendAsync(request);
			return new ResponseMessageResult(response.Result);
		}

		public IHttpActionResult Validate([FromBody] Interface.FKF.Documents.ViewModels.Issue.Simple.DocumentIssue documentIssue)
		{
			throw new NotImplementedException();
		}

		public IHttpActionResult Validate([FromBody] Interface.FKF.Documents.ViewModels.Issue.Custom.DocumentIssue documentIssue)
		{
			throw new NotImplementedException();
		}

		public IHttpActionResult Validate([FromBody] Interface.FKF.Documents.ViewModels.Issue.SaleInvoice.DocumentIssue documentIssue)
		{
			throw new NotImplementedException();
		}

		public IHttpActionResult Validate([FromBody] Interface.FKF.Documents.ViewModels.Issue.PurchaseInvoice.DocumentIssue documentIssue)
		{
			throw new NotImplementedException();
		}
	}
}
