﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.Interchange.Extensions;
using Sage.PL.WebAPI.Interface.Orders.Interfaces;
using Sage.PL.WebAPI.Interface.Orders.ViewModels;
using Unity.Attributes;

namespace Sage.PL.WebAPI.Demo.Interchange.Handlers
{
	public class ForeignOrdersIssueHandler : IOrdersIssueController
	{
		private readonly HttpClient httpClient;
		private readonly string sessionGuid;

		public ForeignOrdersIssueHandler(HttpClient httpClient, [Dependency("SessionGuid")] string sessionGuid)
		{
			this.httpClient = httpClient;
			this.sessionGuid = sessionGuid;
		}

		public IHttpActionResult AddNew(OrderIssue order, bool issue = true)
		{
			Uri uri = httpClient.BaseAddress.SetPath("/api/OrdersIssue/New").AppendQuery(nameof(issue), issue ? "true" : "false");
			var request = new HttpRequestMessage();
			request.RequestUri = uri;
			request.Method = HttpMethod.Post;
			request.Headers.Authorization = new AuthenticationHeaderValue("Session", sessionGuid);
			request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
			request.Content = new ObjectContent<OrderIssue>(order, new JsonMediaTypeFormatter(), new MediaTypeHeaderValue("application/json"));

			var response = httpClient.SendAsync(request);
			return new ResponseMessageResult(response.Result);
		}

		public IHttpActionResult Delete(int id)
		{
			throw new NotImplementedException();
		}

		public IHttpActionResult Delete(string number, bool buffer = false)
		{
			throw new NotImplementedException();
		}

		public IHttpActionResult Edit(OrderEdit order)
		{
			throw new NotImplementedException();
		}

		public IHttpActionResult Issue(int id)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult Issue(string number)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult IssueFV(int orderId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult IssueFV(string orderNumber)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult IssueWZ(int orderId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult IssueWZ(string orderNumber)
		{
			throw new NotImplementedException();
		}
	}
}
