﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.Interchange.Extensions;
using Sage.PL.WebAPI.Interface.Products.Interfaces;
using Sage.PL.WebAPI.Interface.Products.ViewModels.PriceCalculations;
using Sage.PL.WebAPI.Interface.Products.ViewModels.Prices;
using Unity.Attributes;

namespace Sage.PL.WebAPI.Demo.Interchange.Handlers
{
	public class ProductPricesHandler : IProductPricesController
	{
		private readonly HttpClient httpClient;
		private readonly string sessionGuid;

		public ProductPricesHandler(HttpClient httpClient, [Dependency("SessionGuid")] string sessionGuid)
		{
			this.httpClient = httpClient;
			this.sessionGuid = sessionGuid;
		}

		public IHttpActionResult CalculatePrices(PriceCalculationCriteria criteria)
		{
			Uri uri = httpClient.BaseAddress.SetPath("/api/ProductPrices/CalculatePrices");
			var request = new HttpRequestMessage();
			request.RequestUri = uri;
			request.Method = new HttpMethod("PATCH");
			request.Headers.Authorization = new AuthenticationHeaderValue("Session", sessionGuid);
			request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
			request.Content = new ObjectContent<PriceCalculationCriteria>(criteria, new JsonMediaTypeFormatter(), new MediaTypeHeaderValue("application/json"));

			var response = httpClient.SendAsync(request);
			return new ResponseMessageResult(response.Result);
		}
		public IHttpActionResult OrderPrices(PriceOrderCriteria criteria)
		{
			Uri uri = httpClient.BaseAddress.SetPath("/api/ProductPrices/OrderPrices");
			var request = new HttpRequestMessage();
			request.RequestUri = uri;
			request.Method = new HttpMethod("PATCH");
			request.Headers.Authorization = new AuthenticationHeaderValue("Session", sessionGuid);
			request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
			request.Content = new ObjectContent<PriceOrderCriteria>(criteria, new JsonMediaTypeFormatter(), new MediaTypeHeaderValue("application/json"));

			var response = httpClient.SendAsync(request);
			return new ResponseMessageResult(response.Result);
		}

		public IHttpActionResult GetIndividualDiscounts()
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetIndividualDiscountsByContractor(int contractorId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetIndividualDiscountsByContractor(string contractorCode)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetIndividualDiscountsByContractorKind(int contractorKindId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetPriceFactors(PriceFactorCriteria criteria)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetQuantitativeDiscounts()
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetQuantitativeDiscountsByProduct(int productId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetQuantitativeDiscountsByProduct(string productCode)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetQuantitativeDiscountsByProductKind(int productKindId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetSalePrices()
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetSalePricesByProduct(int productId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetSalePricesByProduct(string productCode)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult GetSalePricesByProductKind(int productKindId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult Recalculate(int productId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult Recalculate(string productCode)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult Update(int productId, ProductPricesEdit prices)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult Update(string productCode, ProductPricesEdit prices)
		{
			throw new NotImplementedException();
		}
	}
}
