﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.Interchange.Extensions;
using Sage.PL.WebAPI.Interface.Orders.Interfaces;
using Sage.PL.WebAPI.Interface.Purchases.Interfaces;
using Sage.PL.WebAPI.Interface.Purchases.ViewModels;
using Unity.Attributes;

namespace Sage.PL.WebAPI.Demo.Interchange.Handlers
{
	public class PurchaseDocumentIssueHandler : IPurchasesIssueController
	{
		private readonly HttpClient httpClient;
		private readonly string sessionGuid;

		public PurchaseDocumentIssueHandler(HttpClient httpClient, [Dependency("SessionGuid")] string sessionGuid)
		{
			this.httpClient = httpClient;
			this.sessionGuid = sessionGuid;
		}

		public IHttpActionResult AddNew(PurchaseDocumentIssue document, bool issue = false)
		{
			Uri uri = httpClient.BaseAddress.SetPath("/api/PurchasesIssue/New").AppendQuery(nameof(issue), issue ? "true" : "false");
			var request = new HttpRequestMessage();
			request.RequestUri = uri;
			request.Method = HttpMethod.Post;
			request.Headers.Authorization = new AuthenticationHeaderValue("Session", sessionGuid);
			request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
			request.Content = new ObjectContent<PurchaseDocumentIssue>(document, new JsonMediaTypeFormatter(), new MediaTypeHeaderValue("application/json"));

			var response = httpClient.SendAsync(request);
			return new ResponseMessageResult(response.Result);
		}

		public IHttpActionResult AddNew(PurchaseCorrectionIssue correction, bool issue = false)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult Issue(int id)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult Issue(string number)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult IssuePZ(int documentId)
		{
			throw new NotImplementedException();
		}
		public IHttpActionResult IssuePZ(string documentNumber)
		{
			throw new NotImplementedException();
		}

		public IHttpActionResult IssuePZCorrection(int documentId, bool issue = false)
		{
			throw new NotImplementedException();
		}

		public IHttpActionResult IssuePZCorrection(string documentNumber, bool issue = false)
		{
			throw new NotImplementedException();
		}
	}
}
