﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.Results;
using Sage.PL.WebAPI.Demo.Interchange.Extensions;

namespace Sage.PL.WebAPI.Demo.Interchange.Handlers
{
	public class TestsHandler
	{
		private readonly HttpClient httpClient;

		public TestsHandler(HttpClient httpClient)
		{
			this.httpClient = httpClient;
		}

		public IHttpActionResult CloseSession(string _sessionGuid)
		{
			Uri uri = httpClient.BaseAddress.SetPath("/api/Sessions/CloseSession");
			var request = new HttpRequestMessage();
			request.RequestUri = uri;
			request.Method = HttpMethod.Get;
			request.Headers.Authorization = new AuthenticationHeaderValue("Session", _sessionGuid);
			request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));

			var response = httpClient.SendAsync(request);
			return new ResponseMessageResult(response.Result);
		}
	}
}
