﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using Unity;

namespace Sage.PL.WebAPI.Demo.Bootstrap
{
	public class HttpClientFactory
	{
		private readonly IUnityContainer unityContainer;

		private bool initialized = false;

		public HttpClientFactory(IUnityContainer unityContainer)
		{
			this.unityContainer = unityContainer;
		}

		public HttpClient Initialize(Uri uri)
		{
			if (initialized)
			{
				HttpClient httpClient = unityContainer.Resolve<HttpClient>();
				return httpClient;
			}
			else
			{
				HttpClient httpClient = new HttpClient();
				if (uri != null)
					httpClient.BaseAddress = uri;
				unityContainer.RegisterInstance(httpClient);
				initialized = true;
				return httpClient;
			}
		}
		public HttpClient Temporary(Uri uri)
		{
			HttpClient httpClient = new HttpClient();
			httpClient.BaseAddress = uri;
			unityContainer.RegisterInstance(httpClient);
			return httpClient;
		}
		public string InitializeAppGuid(string guid)
		{
			unityContainer.RegisterInstance("AppGuid", guid);
			return guid;
		}
		public string InitializeSessionGuid(string guid)
		{
			unityContainer.RegisterInstance("SessionGuid", guid);
			return guid;
		}
	}
}
