﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Sage.PL.WebAPI.Demo.Interchange.Handlers;
using Sage.PL.WebAPI.Demo.Mappers;
using Sage.PL.WebAPI.Demo.Services;
using Sage.PL.WebAPI.Interface.Common.Interfaces;
using Sage.PL.WebAPI.Interface.Contractors.Interfaces;
using Sage.PL.WebAPI.Interface.FKF.AccountsChart.Interfaces;
using Sage.PL.WebAPI.Interface.FKF.Common.Interfaces;
using Sage.PL.WebAPI.Interface.FKF.Contractors.Interfaces;
using Sage.PL.WebAPI.Interface.FKF.Documents.Interfaces;
using Sage.PL.WebAPI.Interface.FKF.Employees.Interfaces;
using Sage.PL.WebAPI.Interface.Interfaces;
using Sage.PL.WebAPI.Interface.Orders.Interfaces;
using Sage.PL.WebAPI.Interface.Products.Interfaces;
using Sage.PL.WebAPI.Interface.Purchases.Interfaces;
using Unity;

namespace Sage.PL.WebAPI.Demo.Bootstrap
{
	public class UnityConfig
	{
		private IUnityContainer unityContainer;
		public IUnityContainer UnityContainer
		{
			get { return unityContainer; }
		}

		public void Configure()
		{
			if (unityContainer != null)
				return;

			unityContainer = new UnityContainer();

			unityContainer.RegisterSingleton<DockManagerService>();
			unityContainer.RegisterSingleton<GridControlService>();
			unityContainer.RegisterSingleton<HttpClientFactory>();

			unityContainer.RegisterSingleton<ContractorMapper>();
			unityContainer.RegisterSingleton<ProductMapper>();
			unityContainer.RegisterSingleton<ForeignOrderMapper>();
			unityContainer.RegisterSingleton<PriceTypeMapper>();
			unityContainer.RegisterSingleton<MessagesService>();

			unityContainer.RegisterType<IPingController, PingHandler>();
			unityContainer.RegisterType<IAliveController, AliveHandler>();
			unityContainer.RegisterType<ISessionController, SessionHandler>();
			unityContainer.RegisterType<IContractorsController, ContractorsHandler>();
			unityContainer.RegisterType<IFKContractorsController, FKContractorsHandler>();
			unityContainer.RegisterType<IFKEmployeesController, FKEmployeesHandler>();
			unityContainer.RegisterType<IFKDocumentsController, FKDocumentsHandler>();
			unityContainer.RegisterType<IFKDocumentsIssueController, FKDocumentsIssueHandler>();
			unityContainer.RegisterType<IFKYearsController, FKYearsHandler>();
			unityContainer.RegisterType<IProductsController, ProductsHandler>();
			unityContainer.RegisterType<IOrdersController, ForeignOrdersHandler>();
			unityContainer.RegisterType<ICountriesController, CountriesHandler>();
			unityContainer.RegisterType<IFKCountriesController, FKCountriesHandler>();
			unityContainer.RegisterType<IRegionsController, RegionsHandler>();
			unityContainer.RegisterType<IPaymentRegistriesController, PaymentRegistriesHandler>();
			unityContainer.RegisterType<IPaymentFormsController, PaymentFormsHandler>();
			unityContainer.RegisterType<IPricesController, PricesHandler>();
			unityContainer.RegisterType<ICurrenciesController, CurrenciesHandler>();
			unityContainer.RegisterType<IUnitsOfMeasurementController, UnitsOfMeasurementHandler>();
			unityContainer.RegisterType<IDepartmentsController, DepartmentsHandler>();
			unityContainer.RegisterType<IOrdersIssueController, ForeignOrdersIssueHandler>();
			unityContainer.RegisterType<IFKRegionsController, FKRegionsHandler>();
			unityContainer.RegisterType<IFKAccountsChartController, FKAccountsChartHandler>();
			unityContainer.RegisterType<IProductPricesController, ProductPricesHandler>();
			unityContainer.RegisterType<IPurchasesController, PurchaseDocumentsHandler>();
			unityContainer.RegisterType<IPurchasesIssueController, PurchaseDocumentIssueHandler>();

			HttpClientFactory factory = unityContainer.Resolve<HttpClientFactory>();
			unityContainer.RegisterInstance(factory);
			factory.Initialize(null);
		}
	}
}
