﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DevExpress.XtraEditors;
using DevExpress.XtraLayout;

namespace Sage.PL.WebAPI.Demo.Controls
{
	public class ControlRandomQuantity : XtraUserControl
	{
		private SpinEdit quantityFrom;
		private SpinEdit quantityTo;

		public int QuantityFrom
		{
			get { return Convert.ToInt32(quantityFrom.EditValue); }
		}
		public int QuantityTo
		{
			get { return Convert.ToInt32(quantityTo.EditValue); }
		}

		public ControlRandomQuantity()
		{
			LayoutControl lc = new LayoutControl();
			lc.Dock = DockStyle.Fill;

			quantityFrom = new SpinEdit();
			quantityFrom.Properties.MinValue = 1;
			quantityFrom.Properties.MaxValue = int.MaxValue;
			quantityFrom.Properties.EditMask = "d";
			quantityFrom.EditValue = 1;

			quantityTo = new SpinEdit();
			quantityTo.Properties.MinValue = 1;
			quantityTo.Properties.MaxValue = int.MaxValue;
			quantityTo.Properties.EditMask = "d";
			quantityTo.EditValue = 100;

			lc.AddItem("Od: ", quantityFrom).TextVisible = true;
			lc.AddItem("Do: ", quantityTo).TextVisible = true;
			this.Controls.Add(lc);
			this.Height = 80;
			this.Dock = DockStyle.Top;
		}
	}
}
