﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace Sage.PL.WebAPI.Demo.Extensions
{
	public static class EnumExtensions
	{
		public static string GetDescription(this Enum value)
		{
			FieldInfo fieldInfo = value.GetType().GetField(value.ToString());
			if (fieldInfo == null) return "";
			var attribute = fieldInfo.GetCustomAttributes(typeof(DescriptionAttribute)).FirstOrDefault(x => (x.TypeId as Type).Equals(typeof(DescriptionAttribute))) as DescriptionAttribute;
			return attribute?.Description ?? "";
		}
		public static string GetAttributeDescription<T>(this Enum value) where T : DescriptionAttribute
		{
			FieldInfo fieldInfo = value.GetType().GetField(value.ToString());
			if (fieldInfo == null) return "";
			var attribute = fieldInfo.GetCustomAttributes(typeof(T)).FirstOrDefault(x => (x.TypeId as Type).Equals(typeof(T))) as T;
			return attribute?.Description ?? "";
		}
	}
}
