﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DevExpress.XtraEditors;
using Sage.PL.WebAPI.Demo.Model;

namespace Sage.PL.WebAPI.Demo.Forms
{
	public partial class FormMessages : XtraForm
	{
		private List<MessageModel> messages;

		public FormMessages()
		{
			InitializeComponent();
		}

		public void LoadData(List<MessageModel> messages)
		{
			this.messages = messages;
			gridControlMessages.DataSource = messages;
			gridControlMessages.RefreshDataSource();
		}

		private void simpleButtonOk_Click(object sender, EventArgs e)
		{
			DialogResult = DialogResult.OK;
		}
		private void simpleButtonCopy_Click(object sender, EventArgs e)
		{
			try
			{
				Clipboard.SetText(copyMessage());
			}
			catch { }
		}

		private string copyMessage()
		{
			string result = string.Empty;
			foreach (MessageModel message in messages)
			{
				result += "Komunikat: " + message.Message + Environment.NewLine;
				result += "Data: " + message.DateIssue.ToString("yyyy-MM-dd hh:mm:ss") + Environment.NewLine;
				if (!string.IsNullOrEmpty(message.StackTrace))
					result += "StackTrace: " + message.StackTrace + Environment.NewLine;
				if (!string.IsNullOrEmpty(message.Source))
					result += "Source: " + message.Source + Environment.NewLine;
				if (message.InnerException != null)
				{
					result += "====POCZĄTEK ŚLADU STOSU WYJĄTKÓW WEWNĘTRZNYCH====" + Environment.NewLine;
					result += getExceptionText(message.InnerException);
					result += "====KONIEC ŚLADU STOSU WYJĄTKÓW WEWNĘTRZNYCH====" + Environment.NewLine;
				}
				if (!string.IsNullOrEmpty(message.ModelState))
					result += "Model State: " + message.ModelState;
				result += Environment.NewLine;
			}

			return result;
		}
		private string getExceptionText(Exception exc)
		{
			string toReturn = string.Format("Komunikat: {0} {1} ", exc.Message, Environment.NewLine);
			toReturn += string.Format("StackTrace: {0} {1}", exc.StackTrace, Environment.NewLine);

			if (exc.InnerException != null)
				toReturn += getExceptionText(exc.InnerException) + Environment.NewLine;

			return toReturn;
		}
	}
}
