﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DevExpress.XtraEditors;
using DevExpress.XtraGrid.Columns;
using Sage.PL.WebAPI.Demo.Services;
using Sage.PL.WebAPI.Interface.ViewModels;

namespace Sage.PL.WebAPI.Demo.Forms
{
	public partial class FormPing : XtraForm
	{
		private readonly GridControlService gridControlService;

		public FormPing(GridControlService gridControlService)
		{
			InitializeComponent();
			this.gridControlService = gridControlService;
		}

		public void Initialize(Ping ping)
		{
			gridControlHMF.DataSource = ping.ActiveHMFInfo;
			gridControlITG.DataSource = ping.ActiveITGInfo;
			gridControlModules.DataSource = ping.LoadedModuleInfo;

			gridControlHMF.RefreshDataSource();
			gridControlITG.RefreshDataSource();
			gridControlModules.RefreshDataSource();

			gridViewHMF.PopulateColumns();
			gridViewITG.PopulateColumns();
			gridViewModules.PopulateColumns();

			gridControlService.SetColumnReadOnly(ref gridViewHMF, true);
			gridControlService.SetColumnReadOnly(ref gridViewITG, true);
			gridControlService.SetColumnReadOnly(ref gridViewModules, true);

			gridControlService.SetLocalization(ref gridViewHMF, localizations);
			gridControlService.SetLocalization(ref gridViewITG, localizations);
			gridControlService.SetLocalization(ref gridViewModules, localizations);
		}

		private Dictionary<string, string> localizations = new Dictionary<string, string>()
		{
			{ "ServerName", "Serwer" },
			{ "DatabaseName", "Baza danych" },
			{ "Firm", "Firma" },
			{ "User", "Użytkownik" },
			{ "AssemblyName", "Biblioteka" },
			{ "ModuleName", "Nazwa modułu" },
			{ "ModuleVersion", "Wersja modułu" },
		};
	}
}
