﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Sage.PL.WebAPI.Demo.Model;
using Sage.PL.WebAPI.Interface.Common.ViewModels;

namespace Sage.PL.WebAPI.Demo.Mappers
{
	public class DocumentTypeMapper
	{
		public List<DocumentTypeModel> Map(IEnumerable<DocumentType> list, bool currency)
		{
			if (list == null)
				return null;

			List<DocumentTypeModel> models = new List<DocumentTypeModel>();
			foreach (var type in list)
				models.Add(Map(type, currency));
			return models;
		}
		public DocumentTypeModel Map(DocumentType type, bool currency)
		{
			if (type == null)
				return null;

			DocumentTypeModel model = new DocumentTypeModel();
			model.Id = type.Id;
			model.Code = type.Code;
			model.Currency = currency;

			return model;
		}
	}
}
