﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Sage.PL.WebAPI.Demo.ViewModels;
using Sage.PL.WebAPI.Interface.FKF.Documents.ViewModels.Issue;
using Sage.PL.WebAPI.Interface.FKF.Documents.ViewModels.Issue.Custom;

namespace Sage.PL.WebAPI.Demo.Mappers
{
	public class FKDocumentMapper
	{
		public DocumentIssue Map(FKDocumentViewModel viewModel, int yearId)
		{
			if (viewModel == null)
				return null;

			DocumentIssue document = new DocumentIssue();
			document.TypeCode = viewModel.TypeCode;
			document.YearId = yearId;
			document.DocumentNumber = viewModel.DocumentNumber;
			document.Content = viewModel.Content;

			document.OperationDate = viewModel.OperationDate;
			document.IssueDate = viewModel.IssueDate;
			document.DocumentDate = viewModel.DocumentDate;

			document.Records = new List<DocumentRecordIssue>();
			foreach (var record in viewModel.Records)
			{
				DocumentRecordIssue _record = new DocumentRecordIssue();
				_record.No = record.No;
				_record.SplitNo = _record.SplitNo;
				_record.Side = record.Side;
				_record.ParallelType = Interface.Enums.enumParallelType.Undefined;
				_record.DescriptionKind = Interface.Enums.enumRecordDecsriptionKind.FromDocument;
				_record.Description = record.Description;
				_record.ValuePLN = record.ValuePLN;
				_record.Account = new DocumentRecordAccountIssue()
				{
					Synthetic = record.Synthetic,
					Analytic1 = record.Analytic1,
					Analytic2 = record.Analytic2,
					Analytic3 = record.Analytic3,
					Analytic4 = record.Analytic4,
					Analytic5 = record.Analytic5
				};

				document.Records.Add(_record);
			}

			return document;
		}
	}
}
