﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Sage.PL.WebAPI.Demo.Model;
using Sage.PL.WebAPI.Interface.Contractors.ViewModels;
using Sage.PL.WebAPI.Interface.Products.ViewModels;

namespace Sage.PL.WebAPI.Demo.Mappers
{
	public class ListElementMapper
	{
		public List<ListElementModel> Map(IEnumerable<ContractorListElement> list)
		{
			if (list == null)
				return null;

			List<ListElementModel> models = new List<ListElementModel>();
			foreach (var element in list)
				models.Add(Map(element));

			return models;
		}
		public ListElementModel Map(ContractorListElement element)
		{
			ListElementModel model = new ListElementModel();
			model.Id = element.Id;
			model.Code = element.Code;
			model.Name = element.Name;

			return model;
		}

		public List<ListElementExtModel> Map(IEnumerable<ProductListElement> list)
		{
			if (list == null)
				return null;

			List<ListElementExtModel> models = new List<ListElementExtModel>();
			foreach (var element in list)
				models.Add(Map(element));

			return models;
		}
		public ListElementExtModel Map(ProductListElement element)
		{
			ListElementExtModel model = new ListElementExtModel();
			model.Id = element.Id;
			model.Code = element.Code;
			model.Name = element.Name;

			return model;
		}
	}
}
