﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Sage.PL.WebAPI.Demo.Extensions;
using Sage.PL.WebAPI.Demo.Model;
using Sage.PL.WebAPI.Interface.Attributes;
using Sage.PL.WebAPI.Interface.Common.ViewModels;
using Sage.PL.WebAPI.Interface.Enums;

namespace Sage.PL.WebAPI.Demo.Mappers
{
	public class PriceTypeMapper
	{
		public PriceTypeModel Map(PriceType priceType)
		{
			if (priceType == null)
				return null;

			PriceTypeModel model = new PriceTypeModel();
			model.Type = (enumSalePriceType)priceType.Type;
			model.Code = priceType.Type.GetAttributeDescription<EnumPolishName>();

			return model;
		}
		public List<PriceTypeModel> Map(IEnumerable<PriceType> priceTypes)
		{
			if (priceTypes == null)
				return null;

			List<PriceTypeModel> list = new List<PriceTypeModel>();
			foreach (var priceType in priceTypes)
				list.Add(Map(priceType));

			return list;
		}
	}
}
