﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Sage.PL.WebAPI.Demo.Extensions;
using Sage.PL.WebAPI.Demo.Model;
using Sage.PL.WebAPI.Interface.Attributes;
using Sage.PL.WebAPI.Interface.Products.ViewModels;

namespace Sage.PL.WebAPI.Demo.Mappers
{
	public class ProductMapper
	{
		public ProductModel Map(ProductListElement product)
		{
			if (product == null)
				return null;

			ProductModel model = new ProductModel();
			model.Id = product.Id;
			model.Code = product.Code;
			model.Name = product.Name;
			model.Type = product.Type?.GetAttributeDescription<EnumPolishName>();
			model.Active = product.Active;
			model.Unit = product.Unit;
			model.VatRate = product.VatRate;

			return model;
		}
		public List<ProductModel> Map(IEnumerable<ProductListElement> products)
		{
			if (products == null)
				return null;

			List<ProductModel> list = new List<ProductModel>();
			foreach (var product in products)
				list.Add(Map(product));

			return list;
		}
	}
}
