﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sage.PL.WebAPI.Demo.Model
{
	public class ListElementModel
	{
		[Display(Name = "Id", Order = 2)]
		[ReadOnly(true)]
		public int Id { get; set; }
		[Display(Name = "Kod", Order = 3)]
		[ReadOnly(true)]
		public string Code { get; set; }
		[Display(Name = "Nazwa", Order = 4)]
		[ReadOnly(true)]
		public string Name { get; set; }
		[Display(Name = "Wybierz", Order = 1)]
		public bool Check { get; set; }
	}

	public class ListElementExtModel : ListElementModel
	{
		private decimal quantity = 1m;
		[Display(Name = "Ilość", Order = 5)]
		public decimal Quantity
		{
			get { return quantity; }
			set
			{
				if (value <= decimal.Zero)
					quantity = 1m;
				else
					quantity = value;
			}
		}
	}
}
