﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using DevExpress.LookAndFeel;
using Sage.PL.WebAPI.Demo.Bootstrap;
using Sage.PL.WebAPI.Demo.Forms;
using Unity;
using Unity.Resolution;

namespace Sage.PL.WebAPI.Demo
{
	static class Program
	{
		[STAThread]
		static void Main()
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);

			CultureInfo ci = new CultureInfo("pl-PL");
			Thread.CurrentThread.CurrentUICulture = ci;
			Thread.CurrentThread.CurrentCulture = ci;

			UserLookAndFeel.Default.SkinName = "The Bezier";
			UserLookAndFeel.Default.SetSkinStyle("The Bezier");

			UnityConfig unityConfig = new UnityConfig();
			unityConfig.Configure();

			DialogResult dr = DialogResult.None;
			bool fk = false;
			using (FormLogin formLogin = unityConfig.UnityContainer.Resolve<FormLogin>())
			{
				dr = formLogin.ShowDialog();
				fk = formLogin.FK;
			}

			if (dr != DialogResult.Cancel)
				Application.Run(unityConfig.UnityContainer.Resolve<FormMain>(new ParameterOverride("fk", fk)));
		}
	}
}
