﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DevExpress.XtraEditors.Repository;
using DevExpress.XtraGrid.Columns;
using DevExpress.XtraGrid.Views.BandedGrid;
using DevExpress.XtraGrid.Views.Grid;

namespace Sage.PL.WebAPI.Demo.Services
{
	public class GridControlService
	{
		public void SetColumnReadOnly(ref GridView gridView, bool readOnly)
		{
			foreach (GridColumn column in gridView.Columns)
			{
				column.OptionsColumn.ReadOnly = readOnly;
				column.OptionsColumn.AllowEdit = !readOnly;
			}
		}
		public void SetLocalization(ref GridView gridView, Dictionary<string, string> localizations)
		{
			foreach (GridColumn column in gridView.Columns)
				column.Caption = localizations.ContainsKey(column.FieldName) ? localizations[column.FieldName] : column.FieldName;
		}
		public void AddLookupEdit<T>(ref GridColumn column, IEnumerable<T> list) where T : IIdCode
		{
			RepositoryItemLookUpEdit ri = new RepositoryItemLookUpEdit();
			ri.DataSource = list;
			ri.ValueMember = nameof(IIdCode.Id);
			ri.DisplayMember = nameof(IIdCode.Code);

			column.ColumnEdit = ri;
		}
		public void AddLookupEdit<T>(ref GridColumn column, IEnumerable<T> list, string valueMember, string displayMemeber)
		{
			RepositoryItemLookUpEdit ri = new RepositoryItemLookUpEdit();
			ri.DataSource = list;
			ri.ValueMember = valueMember;
			ri.DisplayMember = displayMemeber;

			column.ColumnEdit = ri;
		}
		public void AddLookupEdit<T>(ref BandedGridColumn column, IEnumerable<T> list, string valueMember, string displayMemeber)
		{
			RepositoryItemLookUpEdit ri = new RepositoryItemLookUpEdit();
			ri.DataSource = list;
			ri.ValueMember = valueMember;
			ri.DisplayMember = displayMemeber;

			column.ColumnEdit = ri;
		}
	}
}
