﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Sage.PL.WebAPI.Interface.Common.ViewModels;
using Sage.PL.WebAPI.Interface.Contractors.ViewModels;
using Sage.PL.WebAPI.Interface.Enums;

namespace Sage.PL.WebAPI.Demo.ViewModels
{
	public class OrderViewModel
	{
		private ContractorListElement buyer;
		public ContractorListElement Buyer
		{
			get { return buyer; }
			set
			{
				buyer = value;
				BuyerName = value?.Name;
				Recipient = value;
			}
		}
		public string BuyerName { get; set; }

		private ContractorListElement recipient;
		public ContractorListElement Recipient
		{
			get { return recipient; }
			set
			{
				recipient = value;
				RecipientName = value?.Name;
			}
		}
		public string RecipientName { get; set; }

		public DateTime IssueDate { get; set; }
		public DateTime SaleDate { get; set; }
		public DateTime MaturityDate { get; set; }

		private PaymentRegistry paymentRegistry;
		public PaymentRegistry PaymentRegistry
		{
			get { return paymentRegistry; }
			set { paymentRegistry = value; }
		}
		private PaymentForm paymentForm;
		public PaymentForm PaymentForm
		{
			get { return paymentForm; }
			set
			{
				paymentForm = value;
				MaturityDate = SaleDate.AddDays(paymentForm?.Days ?? 0);
			}
		}

		public DocumentType DocumentType { get; set; }
		public DocumentSeries DocumentSeries { get; set; }

		public Department Department { get; set; }

		public string RecivedBy { get; set; }
		public string Note { get; set; }
		public string Description { get; set; }

		public enumPriceKind PriceKind { get; set; }
		public enumSalePriceType SalePriceType { get; set; }

		public List<OrderPositionViewModel> Positions { get; set; }
	}
}
