﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sage.PL.WebAPI.Demo.ViewModels
{
	public class PriceResultViewModel
	{
		[ReadOnly(true)]
		[DisplayName("Id kontrahenta")]
		public int ContractorId { get; set; }
		[ReadOnly(true)]
		[DisplayName("Kod kontrahenta")]
		public string ContractorCode { get; set; }
		[ReadOnly(true)]
		[DisplayName("Nazwa kontrahenta")]
		public string ContractorName { get; set; }
		[ReadOnly(true)]
		[DisplayName("Łączny czas realizacji ceny z zamówienia")]
		[Display(AutoGenerateField = false)]
		public TimeSpan? TimeERP { get; set; }
		[ReadOnly(true)]
		[DisplayName("Łączny czas realizacji wyliczenia ceny")]
		[Display(AutoGenerateField = false)]
		public TimeSpan? TimeWAH { get; set; }

		[DisplayName("Id towaru")]
		[ReadOnly(true)]
		public int ProductId { get; set; }
		[DisplayName("Kod towaru")]
		[ReadOnly(true)]
		public string ProductCode { get; set; }
		[DisplayName("Nazwa towaru")]
		[ReadOnly(true)]
		public string ProductName { get; set; }

		[DisplayName("Cena z zamówienia")]
		[ReadOnly(true)]
		public decimal? PriceERP_Raw { get; set; }
		[DisplayName("Cena z zamówienia (zaokrąglona)")]
		[ReadOnly(true)]
		public decimal? PriceERP { get; set; }
		[DisplayName("Cena z algorytmu")]
		[ReadOnly(true)]
		public decimal? PriceWAH_Raw { get; set; }
		[DisplayName("Cena z algorytmu (zaokrąglona)")]
		[ReadOnly(true)]
		public decimal? PriceWAH { get; set; }
		[DisplayName("Różnica (zamówienie - algorytm)")]
		[ReadOnly(true)]
		public decimal? Difference { get; set; }

		[DisplayName("Paczka")]
		[ReadOnly(true)]
		public string GroupText
		{
			get
			{
				return $"Kontrahent: [{ContractorCode}]; Czas wyliczenia cen przez zamówienie: [{TimeERP}]; Czas wyliczenia cen przez algorytm: [{TimeWAH}]";
			}
		}
	}
}
