﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Sage.PL.WebAPI.Interface.Common.ViewModels;
using Sage.PL.WebAPI.Interface.Contractors.ViewModels;
using Sage.PL.WebAPI.Interface.Enums;

namespace Sage.PL.WebAPI.Demo.ViewModels
{
	public class PurchaseDocumentViewModel
	{
		private ContractorListElement seller;
		public ContractorListElement Seller
		{
			get { return seller; }
			set
			{
				seller = value;
				SellerName = value?.Name;
				Deliverer = value;
			}
		}
		public string SellerName { get; set; }

		private ContractorListElement deliverer;
		public ContractorListElement Deliverer
		{
			get { return deliverer; }
			set
			{
				deliverer = value;
				DelivererName = value?.Name;
			}
		}
		public string DelivererName { get; set; }

		public DateTime IssueDate { get; set; }
		public DateTime PurchaseDate { get; set; }
		public DateTime ReceiveDate { get; set; }
		public DateTime ForeignDocumentDate { get; set; }
		public DateTime MaturityDate { get; set; }

		private PaymentRegistry paymentRegistry;
		public PaymentRegistry PaymentRegistry
		{
			get { return paymentRegistry; }
			set { paymentRegistry = value; }
		}
		private PaymentForm paymentForm;
		public PaymentForm PaymentForm
		{
			get { return paymentForm; }
			set
			{
				paymentForm = value;
				MaturityDate = PurchaseDate.AddDays(paymentForm?.Days ?? 0);
			}
		}

		public DocumentType DocumentType { get; set; }
		public DocumentSeries DocumentSeries { get; set; }

		public Department Department { get; set; }

		public string Note { get; set; }
		public string Description { get; set; }
		public string ForeignDocumentNumber { get; set; }

		public enumPriceKind PriceKind { get; set; }

		public List<PurchaseDocumentPositionViewModel> Positions { get; set; }
	}
}
